#!/usr/bin/env python

import sys
import string
import math
import os
import numpy
import re
from Bio import SeqIO

win = 2

base_path = './' 
fasta_path = base_path 


#read seaquence
fasta_sequences = SeqIO.parse(open(fasta_path+'pro.seq'),'fasta')
for fasta in fasta_sequences:
    name, sequence = fasta.id, fasta.seq.tostring()
fastaseq = sequence    
#find N amino acid positions in the sequence
N_index = 0
N_index = [m.start() for m in re.finditer('N', fastaseq)]
if not N_index:
	print ' There is no N-linked (N) glycosylation amino acid in the sequence'


fin = file('prob.txt','r')
lines = fin.read().split('\n')
lines = lines[:-1]

probs = lines[:-1]
gly_type = lines[-1].replace(" ", "")

if gly_type == 'Mouse':
	th = 0.70
elif gly_type == 'Human':
	th = 0.78

## Writting to output file
outfile = file('pro.pdb','w')
cnt = 0
cnt1 = len(fastaseq)
outfile.write("GlycoSegment    \tPos    \tProb    \tGlycoType\n")
outfile.write("====================================================\n")
for item in probs:
#append X residues if there is not enough upstream or down stream 
	if N_index[cnt] < win+1:
		gly_seg = fastaseq[0:N_index[cnt]+win+1]
		start = abs(N_index[cnt]-win)
		for p in xrange(start):
			gly_seg = 'X' + gly_seg
	elif N_index[cnt] >= len(fastaseq)-win:
		gly_seg = fastaseq[N_index[cnt]-win:len(fastaseq)]
		end = len(fastaseq) + (win - (len(fastaseq) - N_index[cnt]))
		while (cnt1 <= end):
			gly_seg = gly_seg + 'X'
			cnt1 += 1
#write in the file
	else:
		gly_seg = fastaseq[N_index[cnt]-win:N_index[cnt]+win+1]
	
	if float(item) <= th:
		outfile.write("%s    \t%s    \t%s    \tnon-glycosite\n" % (gly_seg, str(N_index[cnt]+1), item))
	else:
		outfile.write("%s    \t%s    \t%s    \tglyco-site\n" % (gly_seg, str(N_index[cnt]+1), item))
	cnt += 1
outfile.write("\n*N amino acids with probability higher than threshold are cosidered as predicted glycosite.\n")
outfile.write("Selected thresholds for human and mouse protein are 0.78 and 0.70, respectively.")
outfile.close()
